function Create(self)

	self.RotAngle = 0		--Initial rot angle to 0 so it doesn't spawn tilted

	self.isStable = true;
	self.halfGround = false;
	self.fullGround = false;
	self.canDrive = false;
	
	self.angleNum = 0;
	self.rotateLeft = false
	self.rotateRight = false

	for attachable in self.Attachables do
		if attachable.PresetName == "Loyalist Armored Car Wheel Back" then
			self.WheelB = attachable;
		end
		if attachable.PresetName == "Loyalist Armored Car Wheel Front" then
			self.WheelF = attachable;
		end
	end

	self.Accel = 0.15
	self.MaxAccel = 12
	self.DeAccel = 0.1

	self.wheelsRotCounter = 0
	
	self.debugLines = false

	self.whatAiMode = 0
	self.whatOrientationBool = false
	self.whatOrientation = 0

end

function Update(self)
	
	if self.halfGround == false and self.fullGround == false then
		local rotateUp = self:GetController():IsState(Controller.MOVE_UP);
		local rotateDown = self:GetController():IsState(Controller.MOVE_DOWN);
		
		if rotateUp then
			self.AngularVel = self.AngularVel + 0.05
		elseif rotateDown then
			self.AngularVel = self.AngularVel - 0.05
		end

	end

	if math.abs(self.Vel.Y) >= 5 then
		self.isStable = false
	else
		self.isStable = true
	end

	if self.isStable then

		------------------------- Wheel movement enabler ------------------------------

		local WheelBMovementPosR = self.Pos + Vector(-20*self.FlipFactor, 15):RadRotate(self.RotAngle)		-- -30
		local WheelFMovementPosR = self.Pos + Vector(42*self.FlipFactor, 15):RadRotate(self.RotAngle)		--32		
		local WheelMovementRangeR = Vector(-9*self.FlipFactor, 9)--:RadRotate(self.RotAngle)	--Longer so it doesn't bug

		local WheelBMovementPosL = self.Pos + Vector(-40*self.FlipFactor, 15):RadRotate(self.RotAngle)		-- -30
		local WheelFMovementPosL = self.Pos + Vector(22*self.FlipFactor, 15):RadRotate(self.RotAngle)		--32		
		local WheelMovementRangeL = Vector(9*self.FlipFactor, 9)--:RadRotate(self.RotAngle)	--Longer so it doesn't bug
	
		if self.debugLines == true then
			PrimitiveMan:DrawLinePrimitive(self.Team, WheelBMovementPosR, WheelBMovementPosR + WheelMovementRangeR, 13);
			PrimitiveMan:DrawLinePrimitive(self.Team, WheelFMovementPosR, WheelFMovementPosR + WheelMovementRangeR, 13);
			PrimitiveMan:DrawLinePrimitive(self.Team, WheelBMovementPosL, WheelBMovementPosL + WheelMovementRangeL, 13);
			PrimitiveMan:DrawLinePrimitive(self.Team, WheelFMovementPosL, WheelFMovementPosL + WheelMovementRangeL, 13);
		end
		
		local WheelFMovementCheckR = SceneMan:CastObstacleRay(WheelFMovementPosR, WheelMovementRangeR, Vector(), Vector(), self.ID, self.Team, rte.airID, 0)
		local WheelFMovementCheckL = SceneMan:CastObstacleRay(WheelFMovementPosL, WheelMovementRangeL, Vector(), Vector(), self.ID, self.Team, rte.airID, 0)
		local WheelBMovementCheckR = SceneMan:CastObstacleRay(WheelBMovementPosR, WheelMovementRangeR, Vector(), Vector(), self.ID, self.Team, rte.airID, 0)
		local WheelBMovementCheckL = SceneMan:CastObstacleRay(WheelBMovementPosL, WheelMovementRangeL, Vector(), Vector(), self.ID, self.Team, rte.airID, 0)
	
		local onGround = (WheelFMovementCheckR ~= -1 or WheelFMovementCheckL ~= -1 or WheelBMovementCheckR ~= -1 or WheelBMovementCheckL ~= -1) and true or false
	
		if onGround then
			self.canDrive = true
		else
			self.canDrive = false
		end		

		----------------------------------------------------------------------------------------

		local WheelBFixedPos = self.Pos + Vector(-30*self.FlipFactor, 13):RadRotate(self.RotAngle)		-- -30
		local WheelFFixedPos = self.Pos + Vector(32*self.FlipFactor, 13):RadRotate(self.RotAngle)		--32	

		local WheelRangeFixed = Vector(0, 9):RadRotate(self.RotAngle)	--Longer so it doesn't bug	
		local WheelRangeFixedLR = Vector(9*self.FlipFactor, 4):RadRotate(self.RotAngle)
		local WheelRangeFixedRL = Vector(-9*self.FlipFactor, 4):RadRotate(self.RotAngle)
	
		if self.debugLines == true then
			PrimitiveMan:DrawLinePrimitive(self.Team, WheelBFixedPos, WheelBFixedPos + WheelRangeFixed, 162);
			PrimitiveMan:DrawLinePrimitive(self.Team, WheelBFixedPos, WheelBFixedPos + WheelRangeFixedLR, 162);
			PrimitiveMan:DrawLinePrimitive(self.Team, WheelBFixedPos, WheelBFixedPos + WheelRangeFixedRL, 162);
			
			PrimitiveMan:DrawLinePrimitive(self.Team, WheelFFixedPos, WheelFFixedPos + WheelRangeFixed, 162);
			PrimitiveMan:DrawLinePrimitive(self.Team, WheelFFixedPos, WheelFFixedPos + WheelRangeFixedLR, 162);
			PrimitiveMan:DrawLinePrimitive(self.Team, WheelFFixedPos, WheelFFixedPos + WheelRangeFixedRL, 162);
		end
		
		local WheelBCheck1 = SceneMan:CastObstacleRay(WheelBFixedPos, WheelRangeFixed, Vector(), Vector(), self.ID, self.Team, rte.grassID, 0)
		local WheelBCheck2 = SceneMan:CastObstacleRay(WheelBFixedPos, WheelRangeFixedLR, Vector(), Vector(), self.ID, self.Team, rte.grassID, 0)
		local WheelBCheck3 = SceneMan:CastObstacleRay(WheelBFixedPos, WheelRangeFixedRL, Vector(), Vector(), self.ID, self.Team, rte.grassID, 0)
		
		local WheelFCheck1 = SceneMan:CastObstacleRay(WheelFFixedPos, WheelRangeFixed, Vector(), Vector(), self.ID, self.Team, rte.grassID, 0)
		local WheelFCheck2 = SceneMan:CastObstacleRay(WheelFFixedPos, WheelRangeFixedLR, Vector(), Vector(), self.ID, self.Team, rte.grassID, 0)
		local WheelFCheck3 = SceneMan:CastObstacleRay(WheelFFixedPos, WheelRangeFixedRL, Vector(), Vector(), self.ID, self.Team, rte.grassID, 0)
		
		local WheelBFixed = WheelBCheck1 ~= -1 and WheelBCheck1 or WheelBCheck2 ~= -1 and WheelBCheck2 or WheelBCheck3 ~= -1 and WheelBCheck3 or -1
		local WheelFFixed = WheelFCheck1 ~= -1 and WheelFCheck1 or WheelFCheck2 ~= -1 and WheelFCheck2 or WheelFCheck3 ~= -1 and WheelFCheck3 or -1

		if WheelBFixed ~= -1 and WheelFFixed ~= -1 then			--Full ground. "Generic" specifications. Upwards rotation. 0 Angular vel
			self.fullGround = true;
			self.halfGround = false;
			
			local push = WheelBFixed < WheelFFixed and (8 - WheelBFixed) or (8 - WheelFFixed)
			
			if WheelBFixed <= 8 or WheelFFixed <= 8 then
				self.Vel.Y = 0
				if WheelBFixed < 8 or WheelFFixed < 8 then
					self.Pos = self.Pos - Vector(0, push):RadRotate(self.RotAngle)
				end
			end
		
		elseif WheelBFixed ~= -1 or WheelFFixed ~= -1 then		--Half ground. Wheel specific. Downards rotation. Dependant angular vel for stability
			self.fullGround = false;
			self.halfGround = true;

			local push = 0;

			--This specific system could be converted to rotation (Since rotation also helps unstuck wheels)

			if WheelBFixed == -1 then				--Back wheel is on ground
				push = (8 - WheelFFixed)*0.5 
				if WheelFFixed <= 8 then
					self.Vel.Y = 0
					self.AngularVel = self.AngularVel + 0.65*self.FlipFactor
					if WheelFFixed <= 8 then
						self.Pos = self.Pos - Vector(0, push):RadRotate(self.RotAngle)
					end
				end
			elseif WheelFFixed == -1 then			--Front wheel is on ground
				push = (8 - WheelBFixed)*0.5 
				if WheelBFixed <= 8 then
					self.Vel.Y = 0
					self.AngularVel = self.AngularVel - 0.65*self.FlipFactor
					if WheelBFixed <= 8 then
						self.Pos = self.Pos - Vector(0, push):RadRotate(self.RotAngle)
					end
				end				
			end
			
		elseif self.halfGround or self.fullGround then					--We ere fine and now we trippin balls (Flying, triped, etc). Normal Angular Vel. Previous vel for basic flight
			self.Vel = Vector(self.Vel.X, self.Vel.Y):RadRotate(self.RotAngle)
			self.AngularVel = self.AngularVel
			
			self.halfGround = false
			self.fullGround = false;
		end

		if self.fullGround then		--Might be possible to integrate above, and with angular vel instead of rotation.
		
			if WheelFFixed < WheelBFixed-1 then
				self.rotateLeft = true
			elseif WheelFFixed > WheelBFixed+1 then
				self.rotateRight = true
			end

			if self.rotateRight then
				self.AngularVel = self.AngularVel - 0.1*self.FlipFactor*math.abs(self.Vel.X)
				self.rotateRight = false
			elseif self.rotateLeft then
				self.AngularVel = self.AngularVel + 0.1*self.FlipFactor*math.abs(self.Vel.X)
				self.rotateLeft = false
			else
				self.AngularVel = 0
			end

		end
		
		if self.canDrive then
		
			self.wheelsRotCounter = self.wheelsRotCounter - self.FlipFactor*0.025*math.abs(self.Vel.X)
		
			self.isMovingLeft = self:GetController():IsState(Controller.MOVE_LEFT);
			self.isMovingRight = self:GetController():IsState(Controller.MOVE_RIGHT);
			
			local moving = (self.isMovingLeft or self.isMovingRight) and true or false;
			
			if moving then
			
				for i = 1, 8 do
					local pixelDelete = CreateMOPixel("Armored Car Wheel Terrain Cleaner", "Loyalists.rte")
					pixelDelete.Pos = self.Pos + Vector(-28*self.FlipFactor,14+i):RadRotate(self.RotAngle)
					pixelDelete.Vel = self.Vel + Vector(self.Vel.X*0.85,0):RadRotate(self.RotAngle)
					pixelDelete.Team = self.Team; 
					MovableMan:AddParticle(pixelDelete)
				end

				for i = 1, 8 do
					local pixelDelete = CreateMOPixel("Armored Car Wheel Terrain Cleaner", "Loyalists.rte")
					pixelDelete.Pos = self.Pos + Vector(35*self.FlipFactor,14+i):RadRotate(self.RotAngle)
					pixelDelete.Vel = self.Vel + Vector(self.Vel.X*0.85,0):RadRotate(self.RotAngle)
					pixelDelete.Team = self.Team; 
					MovableMan:AddParticle(pixelDelete)
				end
			end
			
			if self.isMovingLeft then
				if self.Vel.X > (-self.MaxAccel) then
					self.Vel = self.Vel + Vector(-self.Accel ,0):RadRotate(self.RotAngle)
				end
			elseif self.isMovingRight then	
				if self.Vel.X < self.MaxAccel then
					self.Vel = self.Vel + Vector(self.Accel ,0):RadRotate(self.RotAngle)
				end
			else
				if self.Vel.X >= -self.DeAccel and self.Vel.X <= self.DeAccel then
					self.Vel = Vector(0, self.Vel.Y):RadRotate(self.RotAngle)
				elseif self.Vel.X > self.DeAccel then
					self.Vel = self.Vel + Vector(-self.DeAccel, 0):RadRotate(self.RotAngle)
				elseif self.Vel.X < -self.DeAccel then
					self.Vel = self.Vel + Vector(self.DeAccel, 0):RadRotate(self.RotAngle)
				end
			end
		end
	end

	self.wheelsRotCounter = self.wheelsRotCounter - self.FlipFactor*0.01*math.abs(self.Vel.X)

	if math.abs(self.wheelsRotCounter) > 6.3 then		--Full rotation
		self.wheelsRotCounter = 0
	end

	self.WheelB.RotAngle = self.wheelsRotCounter
	self.WheelF.RotAngle = self.wheelsRotCounter

	if self.Health <= 0 then
		self:GibThis()
	else
		self.whatAiMode = self.AIMode
		self.whatOrientationBool = self.HFlipped
		self.whatOrientation = self.FlipFactor
	end

end

function Destroy(self)

	local driver = CreateAHuman("Loyal Officer", "Loyalists.rte")
	local sidearm1 = CreateHDFirearm("Wobbly Revolver" , "Loyalists.rte");
	local melee1 = CreateHDFirearm("Knife" , "Loyalists.rte");
	driver:AddInventoryItem(sidearm1)
	driver:AddInventoryItem(melee1)
	driver.Pos = self.Pos + Vector(20*self.whatOrientation, -5):RadRotate(self.RotAngle)
	driver.Vel = self.Vel
	driver.RotAngle = self.RotAngle
	driver.HFlipped = self.whatOrientationBool
	driver.AIMode = self.whatAiMode
	driver.Team = self.Team
	MovableMan:AddActor(driver)

	local passanger2 = CreateAHuman("Loyalist", "Loyalists.rte")
	local mainarm2 = CreateHDFirearm("Trench MG" , "Loyalists.rte");
	local sidearm2 = CreateHDFirearm("Sawed Shotgun" , "Loyalists.rte");
	passanger2:AddInventoryItem(mainarm2)
	passanger2:AddInventoryItem(sidearm2)
	passanger2.Pos = self.Pos + Vector(0, -15):RadRotate(self.RotAngle)
	passanger2.Vel = self.Vel
	passanger2.RotAngle = self.RotAngle
	passanger2.HFlipped = self.whatOrientationBool
	passanger2.AIMode = self.whatAiMode
	passanger2.Team = self.Team
	MovableMan:AddActor(passanger2)

	local passanger3 = CreateAHuman("Loyalist", "Loyalists.rte")
	local sidearm3 = CreateHDFirearm("Obrez" , "Loyalists.rte");
	local melee3 = CreateHDFirearm("Knife" , "Loyalists.rte");
	passanger3:AddInventoryItem(sidearm3)
	passanger3:AddInventoryItem(melee3)
	passanger3.Pos = self.Pos + Vector(20*self.whatOrientation, -5):RadRotate(self.RotAngle)
	passanger3.Vel = self.Vel
	passanger3.RotAngle = self.RotAngle
	passanger3.HFlipped = self.whatOrientationBool
	passanger3.AIMode = self.whatAiMode
	passanger3.Team = self.Team
	MovableMan:AddActor(passanger3)

end