--[[

	Originally, the Air Balloon took an actor from inside and spawned a COPY of it on the casket
	This looked quite cool, buuuuuut it had some flaws. The copy actor could take damage, and then 
	The new actor would spawn without it (Since it was a copy). Since A fixing this would be time consuming,
	and B I'm a lazy bastard, I've opted to replace that and instead, make the air balloon spawn a special
	pilot actor with a special gun made for the situation.

--]]

function BasketCleanUp(self)
	if self.myBasketActor ~= nil then
		ActivityMan:GetActivity():ReportDeath(self.Team, -1);
		self.myBasketActor.ToDelete = true;
		self.myBasketActor = nil;
	end
end

function Create(self)
	self.Frame = 1;

	self.IgnoresTeamHits = true;
	self.myBasketActor = CreateAHuman("Loyal Pilot", "Loyalists.rte")
	self.myBasketActor:AddInventoryItem(CreateHDFirearm("Aerial Battle Rifle", "Loyalists.rte"));
	self.myBasketActor:AddInventoryItem(CreateHDFirearm("Wobbly Revolver", "Loyalists.rte"));
	self.myBasketActor.Team = self.Team;
	self.myBasketActor.AIMode = Actor.AIMODE_SENTRY
	MovableMan:AddActor(self.myBasketActor);
	
	local attachable
	
	for attachable in self.Attachables do
		if attachable.PresetName == "Loyalists Hot Air Balloon" then
			self.balloon = attachable;
		end
	end
	
	for attachable in self.Attachables do
		if attachable.PresetName == "Loyalists Air Balloon Engine A" then
			self.engine1 = ToAEmitter(attachable);
		end
	end
	
	for attachable in self.Attachables do
		if attachable.PresetName == "Loyalists Air Balloon Engine B" then
			self.engine2 = ToAEmitter(attachable);
		end
	end
	
end

function Update(self)

	if not (self.balloon and self.balloon:IsAttached()) then
		if (self.engine1 and self.engine1:IsAttached()) then
			self.engine1:EnableEmission(false);
		end
		if (self.engine2 and self.engine2:IsAttached()) then
			self.engine2:EnableEmission(false);
		end
		self.GibImpulseLimit = 50
	end
	

	if self:GetController():IsState(Controller.MOVE_LEFT) == false and self:GetController():IsState(Controller.MOVE_RIGHT) == false then
		self.Vel.X = self.Vel.X*.96;
		self.RotAngle = self.RotAngle*.96;
	end

	if self ~= nil then
	
		local ctrl = self:GetController();
		local screen = ActivityMan:GetActivity():ScreenOfPlayer(ctrl.Player);	
					
		local basketFront = CreateMOSRotating("Loyalists Air Balloon Front", "Loyalists.rte");
		local basketFrontPos = self.Pos + Vector(1,-21):RadRotate(self.RotAngle)
						
		PrimitiveMan:DrawBitmapPrimitive(screen, basketFrontPos, basketFront, -(3.14-self.RotAngle), 0, true, true);	
	
		self.AngleRot = math.rad(self.Vel.X*.6);

		if self.myBasketActor ~= nil then
			self.myBasketActor.Pos = self.Pos + Vector(0,-15):RadRotate(self.RotAngle);
			self.myBasketActor.Vel = self.Vel;
			self.myBasketActor.AngularVel = 0;
			self.myBasketActor.RotAngle = self.RotAngle;
			self.myBasketActor:GetController():SetState(Controller.MOVE_UP,false);
			
			if self.Pos.Y < -35 then --and (self.AIMode == Actor.AIMODE_RETURN or self.AIM) then		--Remove actor from the picture
				BasketCleanUp(self);
			end			
		end		
	end
end