function Create(self)

	self.Frame = 1

	self.reloadAngleSize = 0.3;				--Change this if you feel the gun rotates a bit too much or too litle
	self.reloading = false;
	
	self.disabledAngleSize = 0.2
	self.canFire = false;

	self.angleSize = 0;
	self.angleNum = 0;
	self.animating = false;

	self.parent = nil;
	
	for attachable in self.Attachables do
		if attachable.PresetName == "Loyalist Great Machinegun Bipod" then
			self.bipod = attachable;
		end
	end

end

function Update(self)

	if self:IsAttached() == true then 		--I think this is more performance friendly as it doesn't check the parent every frame, rather just when the gun is first taken.
		if self.parent == nil then
			if IsAHuman(self:GetRootParent()) then
				self.parent = ToAHuman(self:GetRootParent())
			end
		end
	else
		self.parent = nil;
	end
	
	if self.Magazine ~= nil then
		self.reloading = false;
	else
		self.reloading = true;
		if self.parent then
			self.parent:GetController():SetState(Controller.AIM_SHARP,false);
		end
	end
	
	if self.reloading then
		self.animating = true
		self.angleSize = self.reloadAngleSize
	else
		self.animating = false
	end
	
	if not self.canFire then
		self.animating = true
		self.angleSize = self.disabledAngleSize
	else
		self.animating = false
	end
	
	if self.parent then
		if self.animating == true then			--Yo we reloading, better grab my weapon better
			if self.angleNum < 1 then
				self.angleNum = self.angleNum +1/self.Mass;
			elseif self.angleNum > 1 then
				self.angleNum = 1;
			end
		elseif	self.animating == false then		--Let's get back into it
			if self.angleNum > 0 then
				self.angleNum = self.angleNum -1/self.Mass;
			elseif self.angleNum < 0 then
				self.angleNum = 0;
			end
		end
		self.RotAngle = self.RotAngle+self.FlipFactor*self.angleNum*self.angleSize;		--The numbers above affect the rotation operation here
	else
		self.angleNum = 0;
	end
	
	if self.parent then
		local controller = self.parent:GetController();
		local isMoving = controller:IsState(Controller.MOVE_LEFT) == true or controller:IsState(Controller.MOVE_RIGHT) == true
		local isAiming = controller:IsState(Controller.AIM_SHARP) == true;
		
		if not isAiming and not self:IsActivated() then
			self.canFire = false;
		else
			self.canFire = true;
		end
		
		if not self.canFire then
			self:Deactivate()
		end
	end
end

--[[

	De forma normal no se va a poder hacer.
	Tendra que usar el sistema avanzado de animacionTM.
	Aparte de eso hay otro problema que concierne al bipod
	Requerira de un segundo script de movimiento especifico para el bipod
	Tendra que tener en cuenta la animacion del arma en si
		-Seguir su rotacion como base.
		-Añadir a lo script normal la rotacion especifica.
		
	Tras eso, cambiar los valores del arma no sera muy dificil
	Comprobar pixel/s de terrain debajo del bipod, y mejorar estabilidad si hay
	¿Hacer que mejore estabilidad como bonus si se esta tirado?


--]]

